Generator 函数的语法

Generator 函数的语法

  1. 简介
  2. next方法的参数
  3. for…of循环
  4. Generator.prototype.throw())
  5. Generator.prototype.return())
  6. yield*
    语句
  7. 用作靶子属性的Generator函数
  8. Generator函数的this
  9. 含义
  10. 应用

简介

基本概念

Generator 函数是 ES6
提供的一种异步编制程序消除方案,语法行为与古板函数完全不一样。本章详细介绍Generator
函数的语法和 API,它的异步编制程序应用请看《Generator 函数的异步应用》一章。

Generator 函数有多样了然角度。从语法上,首先能够把它理解成,Generator
函数是三个状态机,封装了八个里头意况。

执行 Generator 函数会重回1个遍历器对象,也正是说,Generator
函数除了状态机,照旧一个遍历器对象生成函数。再次回到的遍历器对象,能够依次遍历
Generator 函数内部的每二个情景。

花样上,Generator
函数是多个家常函数,但是有两脾性状。一是,function重中之重字与函数名以内有一个星号;二是,函数体内部使用yield言语,定义分歧的里边情状(yield在保加那格浦尔语里的意味便是“产出”)。

function* helloWorldGenerator() {
  yield 'hello';
  yield 'world';
  return 'ending';
}

var hw = helloWorldGenerator();

地方代码定义了1个Generator函数helloWorldGenerator,它里面有多个yield语句“hello”和“world”,即该函数有多个意况:hello,world和return语句(截止执行)。

然后,Generator函数的调用方法与一般函数一样,也是在函数名背后加上一对圆括号。差别的是,调用Generator函数后,该函数并不进行,重回的也不是函数运营结果,而是1个针对内部意况的指针对象,也正是上一章介绍的遍历器对象(Iterator
Object)。

下一步,必须调用遍历器对象的next方法,使得指针移向下多个情景。相当于说,每趟调用next办法,内部指针就从函数底部或上贰遍停下来的地点先河施行,直到蒙受下一个yield语句(或return讲话)截止。换言之,Generator函数是分支执行的,yield言辞是暂停实施的符号,而next艺术能够苏醒执行。

hw.next()
// { value: 'hello', done: false }

hw.next()
// { value: 'world', done: false }

hw.next()
// { value: 'ending', done: true }

hw.next()
// { value: undefined, done: true }

上边代码一共调用了肆次next方法。

首先次调用,Generator函数开端执行,直到遇到第一个yield言语截止。next办法再次回到二个目的,它的value质量正是当前yield言语的值hello,done特性的值false,表示遍历还不曾终结。

第一遍调用,Generator函数从上次yield说话停下的地点,一贯施行到下2个yield语句。next办法再次来到的目的的value性子正是最近yield说话的值world,done个性的值false,表示遍历还平昔不甘休。

其1次调用,Generator函数从上次yield话语停下的地点,一向施行到return言辞(假诺没有return语句,就执行到函数停止)。next艺术重回的指标的value性情,正是紧跟在return讲话前面包车型客车表明式的值(假如没有return语句,则value属性的值为undefined),done天性的值true,表示遍历已经终止。

第十三回调用,此时Generator函数已经运转完结,next情势重临对象的value属性为undefined,done属性为true。今后再调用next措施,重临的都以那么些值。

总计一下,调用Generator函数,重回1个遍历器对象,代表Generator函数的中间指针。今后,每一回调用遍历器对象的next艺术,就会重临3个拥有valuedone两脾本性的对象。value品质表示如今的在那之中景观的值,是yield话语前边那些表明式的值;done属性是二个布尔值,表示是还是不是遍历截至。

ES6没有分明,function首要字与函数名之间的星号,写在哪个岗位。那致使上边包车型地铁写法都能因此。

function * foo(x, y) { ··· }

function *foo(x, y) { ··· }

function* foo(x, y) { ··· }

function*foo(x, y) { ··· }

出于Generator函数依然是数见不鲜函数,所以一般的写法是地点的第三种,即星号紧跟在function重在字背后。本书也利用那种写法。

yield语句

由于Generator函数重回的遍历器对象,唯有调用next办法才会遍历下1个里边情形,所以实际上提供了一种能够暂停实施的函数。yield话语就是暂停标志。

遍历器对象的next主意的运作逻辑如下。

(1)遇到yield话语,就半上落下实施前面包车型大巴操作,并将紧跟在yield末尾的不得了表明式的值,作为再次来到的靶子的value属性值。

(2)下一遍调用next方法时,再持续往下实行,直到遭遇下二个yield语句。

(3)假如没有再遇上新的yield说话,就一贯运维到函数甘休,直到return话语截至,并将return言辞前边的表明式的值,作为重临的目的的value属性值。

(4)假若该函数没有return言辞,则赶回的靶子的value属性值为undefined

内需留意的是,yield言辞前边的表达式,唯有当调用next艺术、内部指针指向该语句时才会实施,因而等于为JavaScript提供了手动的“惰性求值”(Lazy
伊娃luation)的语法功效。

function* gen() {
  yield  123 + 456;
}

上边代码中,yield后边的表达式123 + 456,不会登时求值,只会在next办法将指针移到这一句时,才会求值。

yield语句与return言辞既有相似之处,也有分别。相似之处在于,都能回到紧跟在言语前边的可怜表明式的值。差异在于每一回遇到yield,函数暂停实施,下3回再从该职位连续向后实施,而return语句不抱有地点纪念的效劳。贰个函数里面,只好进行叁遍(可能说一个)return话语,不过足以实施多次(或然说几个)yield说话。正常函数只好回去3个值,因为只好执行2次return;Generator函数能够回去一多级的值,因为能够有自由七个yield。从另四个角度看,也得以说Generator生成了一雨后春笋的值,这也便是它的名称的来头(在拉脱维亚语中,generator这几个词是“生成器”的情趣)。

Generator函数能够不用yield说话,那时就变成了贰个只是的暂缓执行函数。

function* f() {
  console.log('执行了!')
}

var generator = f();

setTimeout(function () {
  generator.next()
}, 2000);

地点代码中,函数f倘即使不以为奇函数,在为变量generator赋值时就会举办。可是,函数f是多少个Generator函数,就改成唯有调用next方法时,函数f才会进行。

除此以外部要求要小心,yield语句不可能用在日常函数中,不然会报错。

(function (){
  yield 1;
})()
// SyntaxError: Unexpected number

上边代码在2个一般函数中采用yield说话,结果爆发二个句法错误。

下边是其余一个事例。

var arr = [1, [[2, 3], 4], [5, 6]];

var flat = function* (a) {
  a.forEach(function (item) {
    if (typeof item !== 'number') {
      yield* flat(item);
    } else {
      yield item;
    }
  }
};

for (var f of flat(arr)){
  console.log(f);
}

地点代码也会爆发句法错误,因为forEach主意的参数是叁个平淡无奇函数,但是在内部使用了yield言辞(那几个函数里面还接纳了yield*话语,那里可以不用理会,详细表达见后文)。一种修章是改用for循环。

var arr = [1, [[2, 3], 4], [5, 6]];

var flat = function* (a) {
  var length = a.length;
  for (var i = 0; i < length; i++) {
    var item = a[i];
    if (typeof item !== 'number') {
      yield* flat(item);
    } else {
      yield item;
    }
  }
};

for (var f of flat(arr)) {
  console.log(f);
}
// 1, 2, 3, 4, 5, 6

另外,yield语句如若用在1个表明式之中,必须放在圆括号内部。

console.log('Hello' + yield); // SyntaxError
console.log('Hello' + yield 123); // SyntaxError

console.log('Hello' + (yield)); // OK
console.log('Hello' + (yield 123)); // OK

yield言辞用作函数参数或赋值表明式的右手,能够不加括号。

foo(yield 'a', yield 'b'); // OK
let input = yield; // OK

与Iterator接口的涉嫌

上一章说过,任意三个指标的Symbol.iterator艺术,等于该对象的遍历器生成函数,调用该函数会再次来到该目的的三个遍历器对象。

是因为Generator函数正是遍历器生成函数,因而能够把Generator赋值给指标的Symbol.iterator属性,从而使得该指标具备Iterator接口。

var myIterable = {};
myIterable[Symbol.iterator] = function* () {
  yield 1;
  yield 2;
  yield 3;
};

[...myIterable] // [1, 2, 3]

地点代码中,Generator函数赋值给Symbol.iterator天性,从而使得myIterable目的具备了Iterator接口,能够被...运算符遍历了。

Generator函数执行后,重临三个遍历器对象。该目的自笔者也持有Symbol.iterator品质,执行后重返本人。

function* gen(){
  // some code
}

var g = gen();

g[Symbol.iterator]() === g
// true

地方代码中,gen是八个Generator函数,调用它会转移三个遍历器对象g。它的Symbol.iterator个性,也是一个遍历器对象生成函数,执行后归来它本人。

next方法的参数

yield句笔者并未重临值,恐怕说总是回到undefinednext办法能够带一个参数,该参数就会被用作上二个yield言语的重回值。

function* f() {
  for(var i = 0; true; i++) {
    var reset = yield i;
    if(reset) { i = -1; }
  }
}

var g = f();

g.next() // { value: 0, done: false }
g.next() // { value: 1, done: false }
g.next(true) // { value: 0, done: false }

上面代码先定义了四个足以极其运营的 Generator
函数f,如果next主意没有参数,每一次运转到yield语句,变量reset的值总是undefined。当next方法带三个参数true时,变量reset就被重置为这几个参数(即true),因此i会等于-1,下一轮循环就会从-1起来递增。

这几个效用有很要紧的语法意义。Generator
函数从暂停状态到苏醒运营,它的上下文状态(context)是不变的。通过next主意的参数,就有方法在
Generator 函数开端运营之后,继续向函数体内部注入值。也正是说,能够在
Generator
函数运转的例外等级,从外表向里面注入差别的值,从而调整函数行为。

再看一个例证。

function* foo(x) {
  var y = 2 * (yield (x + 1));
  var z = yield (y / 3);
  return (x + y + z);
}

var a = foo(5);
a.next() // Object{value:6, done:false}
a.next() // Object{value:NaN, done:false}
a.next() // Object{value:NaN, done:true}

var b = foo(5);
b.next() // { value:6, done:false }
b.next(12) // { value:8, done:false }
b.next(13) // { value:42, done:true }

上面代码中,第③遍运营next方法的时候不带参数,导致y的值等于2 * undefined(即NaN),除以3随后要么NaN,由此回到对象的value个性也格外NaN。第二回运营Next措施的时候不带参数,所以z等于undefined,再次回到对象的value个性等于5 + NaN + undefined,即NaN

如果向next主意提供参数,再次来到结果就全盘不均等了。上边代码第二次调用bnext方法时,返回x+1的值6;第3次调用next办法,将上壹遍yield讲话的值设为12,由此y等于24,返回y / 3的值8;第③回调用next办法,将上二遍yield话语的值设为13,由此z等于13,这时x等于5,y等于24,所以return言辞的值等于42。

注意,由于next方法的参数表示上1个yield话语的再次来到值,所以率先次利用next方式时,不可能带有参数。V8引擎直接忽略第③遍使用next主意时的参数,唯有从第三回选择next方式伊始,参数才是实惠的。从语义上讲,第二个next主意用来运行遍历器对象,所以不用带有参数。

借使想要第三遍调用next办法时,就可见输入值,能够在Generator函数外面再包一层。

function wrapper(generatorFunction) {
  return function (...args) {
    let generatorObject = generatorFunction(...args);
    generatorObject.next();
    return generatorObject;
  };
}

const wrapped = wrapper(function* () {
  console.log(`First input: ${yield}`);
  return 'DONE';
});

wrapped().next('hello!')
// First input: hello!

上边代码中,Generator函数假设不用wrapper先包一层,是无能为力第二遍调用next措施,就输入参数的。

再看一个因而next办法的参数,向Generator函数内部输入值的例证。

function* dataConsumer() {
  console.log('Started');
  console.log(`1. ${yield}`);
  console.log(`2. ${yield}`);
  return 'result';
}

let genObj = dataConsumer();
genObj.next();
// Started
genObj.next('a')
// 1. a
genObj.next('b')
// 2. b

地方代码是3个很直观的例子,每一趟通过next方法向Generator函数输入值,然后打字与印刷出来。

for…of循环

for...of巡回能够自动遍历Generator函数时生成的Iterator指标,且此时不再须求调用next方法。

function *foo() {
  yield 1;
  yield 2;
  yield 3;
  yield 4;
  yield 5;
  return 6;
}

for (let v of foo()) {
  console.log(v);
}
// 1 2 3 4 5

地点代码应用for...of巡回,依次展现多少个yield话语的值。那里必要留意,一旦next办法的回来对象的done属性为truefor...of巡回就会半途而废,且不含有该再次来到对象,所以地点代码的return语句返回的6,不包涵在for...of循环之中。

下边是三个应用Generator函数和for...of循环,实现斐波那契数列的例子。

function* fibonacci() {
  let [prev, curr] = [0, 1];
  for (;;) {
    [prev, curr] = [curr, prev + curr];
    yield curr;
  }
}

for (let n of fibonacci()) {
  if (n > 1000) break;
  console.log(n);
}

从地方代码可知,使用for...of言辞时不须求选拔next方法。

利用for...of巡回,能够写出遍历任意对象(object)的方法。原生的JavaScript对象没有遍历接口,不只怕选用for...of巡回,通过Generator函数为它充足那一个接口,就能够用了。

function* objectEntries(obj) {
  let propKeys = Reflect.ownKeys(obj);

  for (let propKey of propKeys) {
    yield [propKey, obj[propKey]];
  }
}

let jane = { first: 'Jane', last: 'Doe' };

for (let [key, value] of objectEntries(jane)) {
  console.log(`${key}: ${value}`);
}
// first: Jane
// last: Doe

下边代码中,对象jane原生不享有Iterator接口,相当小概用for...of遍历。那时,大家经过Generator函数objectEntries为它充分遍历器接口,就足以用for...of遍历了。加上遍历器接口的另一种写法是,将Generator函数加到对象的Symbol.iterator质量下边。

function* objectEntries() {
  let propKeys = Object.keys(this);

  for (let propKey of propKeys) {
    yield [propKey, this[propKey]];
  }
}

let jane = { first: 'Jane', last: 'Doe' };

jane[Symbol.iterator] = objectEntries;

for (let [key, value] of jane) {
  console.log(`${key}: ${value}`);
}
// first: Jane
// last: Doe

除了for...of巡回以外,扩张运算符(...)、解构赋值和Array.from主意内部调用的,都以遍历器接口。那意味,它们都能够将Generator函数重临的Iterator对象,作为参数。

function* numbers () {
  yield 1
  yield 2
  return 3
  yield 4
}

// 扩展运算符
[...numbers()] // [1, 2]

// Array.from 方法
Array.from(numbers()) // [1, 2]

// 解构赋值
let [x, y] = numbers();
x // 1
y // 2

// for...of 循环
for (let n of numbers()) {
  console.log(n)
}
// 1
// 2

Generator.prototype.throw()

Generator函数重临的遍历器对象,都有叁个throw主意,能够在函数体外抛出错误,然后在Generator函数体内破获。

var g = function* () {
  try {
    yield;
  } catch (e) {
    console.log('内部捕获', e);
  }
};

var i = g();
i.next();

try {
  i.throw('a');
  i.throw('b');
} catch (e) {
  console.log('外部捕获', e);
}
// 内部捕获 a
// 外部捕获 b

地方代码中,遍历器对象i连年抛出多少个错误。第③个谬误被Generator函数体内的catch语句捕获。i第三次抛出错误,由于Generator函数内部的catch讲话已经施行过了,不会再捕捉到那么些荒唐了,所以这一个漏洞非常多就被抛出了Generator函数体,被函数体外的catch语句捕获。

throw措施能够承受三个参数,该参数会被catch说话接收,提议抛出Error指标的实例。

var g = function* () {
  try {
    yield;
  } catch (e) {
    console.log(e);
  }
};

var i = g();
i.next();
i.throw(new Error('出错了!'));
// Error: 出错了!(…)

留意,不要混淆遍历器对象的throw情势和大局的throw指令。上面代码的一无是处,是用遍历器对象的throw艺术抛出的,而不是用throw命令抛出的。后者只好被函数体外的catch语句捕获。

var g = function* () {
  while (true) {
    try {
      yield;
    } catch (e) {
      if (e != 'a') throw e;
      console.log('内部捕获', e);
    }
  }
};

var i = g();
i.next();

try {
  throw new Error('a');
  throw new Error('b');
} catch (e) {
  console.log('外部捕获', e);
}
// 外部捕获 [Error: a]

上边代码之所以只捕获了a,是因为函数体外的catch语句块,捕获了抛出的a谬误以往,就不会再持续try代码块里面剩余的语句了。

借使Generator函数内部尚未布署try...catch代码块,那么throw措施抛出的荒谬,将被表面try...catch代码块捕获。

var g = function* () {
  while (true) {
    yield;
    console.log('内部捕获', e);
  }
};

var i = g();
i.next();

try {
  i.throw('a');
  i.throw('b');
} catch (e) {
  console.log('外部捕获', e);
}
// 外部捕获 a

地点代码中,Generator函数g里头没有安顿try...catch代码块,所以抛出的荒谬直接被外表catch代码块捕获。

一经Generator函数内部和外部,都未曾配置try...catch代码块,那么程序将报错,直接中断执行。

var gen = function* gen(){
  yield console.log('hello');
  yield console.log('world');
}

var g = gen();
g.next();
g.throw();
// hello
// Uncaught undefined

地点代码中,g.throw抛出错误现在,没有别的try...catch代码块能够捕获那一个错误,导致程序报错,中断执行。

throw主意被抓走现在,会顺便执行下一条yield言语。也正是说,会有意无意执行3回next方法。

var gen = function* gen(){
  try {
    yield console.log('a');
  } catch (e) {
    // ...
  }
  yield console.log('b');
  yield console.log('c');
}

var g = gen();
g.next() // a
g.throw() // b
g.next() // c

地点代码中,g.throw措施被擒获未来,自动执行了一遍next形式,所以会打印b。其它,也足以看来,只要Generator函数内部安排了try...catch代码块,那么遍历器的throw方法抛出的失实,不影响下贰次遍历。

另外,throw命令与g.throw措施是风马牛不相干的,两者互不影响。

var gen = function* gen(){
  yield console.log('hello');
  yield console.log('world');
}

var g = gen();
g.next();

try {
  throw new Error();
} catch (e) {
  g.next();
}
// hello
// world

地方代码中,throw指令抛出的不当不会影响到遍历器的意况,所以一遍施行next方式,都开始展览了未可厚非的操作。

这种函数体内破获错误的编写制定,大大方便了对错误的处理。五个yield言语,能够只用三个try...catch代码块来捕获错误。假如利用回调函数的写法,想要捕获多少个谬误,就只可以为各类函数内部写一个错误处理语句,今后只在Generator函数内部写3回catch讲话就足以了。

Generator函数体外抛出的失实,可以在函数体内破获;反过来,Generator函数体内抛出的不当,也足以被函数体外的catch捕获。

function *foo() {
  var x = yield 3;
  var y = x.toUpperCase();
  yield y;
}

var it = foo();

it.next(); // { value:3, done:false }

try {
  it.next(42);
} catch (err) {
  console.log(err);
}

上边代码中,第1个next艺术向函数体内传来贰个参数42,数值是从未toUpperCase办法的,所以会抛出二个TypeError错误,被函数体外的catch捕获。

若果Generator执行进度中抛出错误,且尚未被中间捕获,就不会再实践下去了。要是之后还调用next措施,将赶回二个value质量等于undefineddone性格等于true的靶子,即JavaScript引擎认为那些Generator已经运营结束了。

function* g() {
  yield 1;
  console.log('throwing an exception');
  throw new Error('generator broke!');
  yield 2;
  yield 3;
}

function log(generator) {
  var v;
  console.log('starting generator');
  try {
    v = generator.next();
    console.log('第一次运行next方法', v);
  } catch (err) {
    console.log('捕捉错误', v);
  }
  try {
    v = generator.next();
    console.log('第二次运行next方法', v);
  } catch (err) {
    console.log('捕捉错误', v);
  }
  try {
    v = generator.next();
    console.log('第三次运行next方法', v);
  } catch (err) {
    console.log('捕捉错误', v);
  }
  console.log('caller done');
}

log(g());
// starting generator
// 第一次运行next方法 { value: 1, done: false }
// throwing an exception
// 捕捉错误 { value: 1, done: false }
// 第三次运行next方法 { value: undefined, done: true }
// caller done

地点代码一共三回运转next主意,第3遍运维的时候会抛出错误,然后第①次运转的时候,Generator函数就曾经竣事了,不再执行下去了。

Generator.prototype.return()

Generator函数重返的遍历器对象,还有多少个return措施,能够再次回到给定的值,并且终结遍历Generator函数。

function* gen() {
  yield 1;
  yield 2;
  yield 3;
}

var g = gen();

g.next()        // { value: 1, done: false }
g.return('foo') // { value: "foo", done: true }
g.next()        // { value: undefined, done: true }

上边代码中,遍历器对象g调用return主意后,再次回到值的value性情就是return方式的参数foo。并且,Generator函数的遍历就终止了,再次回到值的done属性为true,现在再调用next方法,done属性总是回到true

如果return方法调用时,不提供参数,则重临值的value属性为undefined

function* gen() {
  yield 1;
  yield 2;
  yield 3;
}

var g = gen();

g.next()        // { value: 1, done: false }
g.return() // { value: undefined, done: true }

设若Generator函数内部有try...finally代码块,那么return方法会推迟到finally代码块执行完再进行。

function* numbers () {
  yield 1;
  try {
    yield 2;
    yield 3;
  } finally {
    yield 4;
    yield 5;
  }
  yield 6;
}
var g = numbers()
g.next() // { done: false, value: 1 }
g.next() // { done: false, value: 2 }
g.return(7) // { done: false, value: 4 }
g.next() // { done: false, value: 5 }
g.next() // { done: true, value: 7 }

ECMAScript,地点代码中,调用return措施后,就最施夷光行finally代码块,然后等到finally代码块执行完,再实践return方法。

yield* 语句

只要在 Generator 函数内部,调用另五个 Generator
函数,暗中同意情形下是一向不效应的。

function* foo() {
  yield 'a';
  yield 'b';
}

function* bar() {
  yield 'x';
  foo();
  yield 'y';
}

for (let v of bar()){
  console.log(v);
}
// "x"
// "y"

上面代码中,foobar都是 Generator
函数,在bar中间调用foo,是不会有效益的。

其一就须求选取yield*言辞,用来在三个 Generator 函数里面实践另2个Generator 函数。

function* bar() {
  yield 'x';
  yield* foo();
  yield 'y';
}

// 等同于
function* bar() {
  yield 'x';
  yield 'a';
  yield 'b';
  yield 'y';
}

// 等同于
function* bar() {
  yield 'x';
  for (let v of foo()) {
    yield v;
  }
  yield 'y';
}

for (let v of bar()){
  console.log(v);
}
// "x"
// "a"
// "b"
// "y"

再来看3个比照的例子。

function* inner() {
  yield 'hello!';
}

function* outer1() {
  yield 'open';
  yield inner();
  yield 'close';
}

var gen = outer1()
gen.next().value // "open"
gen.next().value // 返回一个遍历器对象
gen.next().value // "close"

function* outer2() {
  yield 'open'
  yield* inner()
  yield 'close'
}

var gen = outer2()
gen.next().value // "open"
gen.next().value // "hello!"
gen.next().value // "close"

上边例子中,outer2使用了yield*outer1没利用。结果正是,outer1回到二个遍历器对象,outer2归来该遍历器对象的里边值。

从语法角度看,如若yield命令后边跟的是1个遍历器对象,须求在yield命令后边加上星号,注解它回到的是1个遍历器对象。那被誉为yield*语句。

let delegatedIterator = (function* () {
  yield 'Hello!';
  yield 'Bye!';
}());

let delegatingIterator = (function* () {
  yield 'Greetings!';
  yield* delegatedIterator;
  yield 'Ok, bye.';
}());

for(let value of delegatingIterator) {
  console.log(value);
}
// "Greetings!
// "Hello!"
// "Bye!"
// "Ok, bye."

地方代码中,delegatingIterator是代理者,delegatedIterator是被代理者。由于yield* delegatedIterator语句获得的值,是3个遍历器,所以要用星号表示。运转结果正是行使叁个遍历器,遍历了三个Generator函数,有递归的效应。

yield*后面的Generator函数(没有return语句时),等同于在Generator函数内部,布署二个for...of循环。

function* concat(iter1, iter2) {
  yield* iter1;
  yield* iter2;
}

// 等同于

function* concat(iter1, iter2) {
  for (var value of iter1) {
    yield value;
  }
  for (var value of iter2) {
    yield value;
  }
}

上面代码表达,yield*后面的Generator函数(没有return语句时),不过是for...of的一种简写方式,完全能够用后世替代前者。反之,则必要用var value = yield* iterator的款型取得return言辞的值。

如果yield*背后随着二个数组,由于数组原生扶助遍历器,由此就会遍历数组成员。

function* gen(){
  yield* ["a", "b", "c"];
}

gen().next() // { value:"a", done:false }

上边代码中,yield指令后边假若不加星号,重回的是成套数组,加了星号就表示回去的是数组的遍历器对象。

实际,任何数据结构只要有Iterator接口,就能够被yield*遍历。

let read = (function* () {
  yield 'hello';
  yield* 'hello';
})();

read.next().value // "hello"
read.next().value // "h"

地点代码中,yield语句重回整个字符串,yield*语句重回单个字符。因为字符串具有Iterator接口,所以被yield*遍历。

假设被代理的Generator函数有return话语,那么就能够向代理它的Generator函数再次回到数据。

function *foo() {
  yield 2;
  yield 3;
  return "foo";
}

function *bar() {
  yield 1;
  var v = yield *foo();
  console.log( "v: " + v );
  yield 4;
}

var it = bar();

it.next()
// {value: 1, done: false}
it.next()
// {value: 2, done: false}
it.next()
// {value: 3, done: false}
it.next();
// "v: foo"
// {value: 4, done: false}
it.next()
// {value: undefined, done: true}

下边代码在第八遍调用next措施的时候,显示屏上会有出口,那是因为函数fooreturn语句,向函数bar提供了重临值。

再看贰个例子。

function* genFuncWithReturn() {
  yield 'a';
  yield 'b';
  return 'The result';
}
function* logReturned(genObj) {
  let result = yield* genObj;
  console.log(result);
}

[...logReturned(genFuncWithReturn())]
// The result
// 值为 [ 'a', 'b' ]

地点代码中,存在五回遍历。第②遍是扩大运算符遍历函数logReturned回去的遍历器对象,第一回是yield*言语遍历函数genFuncWithReturn回来的遍历器对象。这一回遍历的功用是增大的,最后呈现为增添运算符遍历函数genFuncWithReturn归来的遍历器对象。所以,最后的数量表达式获得的值等于[ 'a', 'b' ]。但是,函数genFuncWithReturnreturn讲话的重临值The result,会重临给函数logReturned内部的result变量,由此会有终点输出。

yield*指令能够很便宜地取出嵌套数组的富有成员。

function* iterTree(tree) {
  if (Array.isArray(tree)) {
    for(let i=0; i < tree.length; i++) {
      yield* iterTree(tree[i]);
    }
  } else {
    yield tree;
  }
}

const tree = [ 'a', ['b', 'c'], ['d', 'e'] ];

for(let x of iterTree(tree)) {
  console.log(x);
}
// a
// b
// c
// d
// e

上面是三个多少复杂的例证,使用yield*话语遍历完全二叉树。

// 下面是二叉树的构造函数,
// 三个参数分别是左树、当前节点和右树
function Tree(left, label, right) {
  this.left = left;
  this.label = label;
  this.right = right;
}

// 下面是中序(inorder)遍历函数。
// 由于返回的是一个遍历器,所以要用generator函数。
// 函数体内采用递归算法,所以左树和右树要用yield*遍历
function* inorder(t) {
  if (t) {
    yield* inorder(t.left);
    yield t.label;
    yield* inorder(t.right);
  }
}

// 下面生成二叉树
function make(array) {
  // 判断是否为叶节点
  if (array.length == 1) return new Tree(null, array[0], null);
  return new Tree(make(array[0]), array[1], make(array[2]));
}
let tree = make([[['a'], 'b', ['c']], 'd', [['e'], 'f', ['g']]]);

// 遍历二叉树
var result = [];
for (let node of inorder(tree)) {
  result.push(node);
}

result
// ['a', 'b', 'c', 'd', 'e', 'f', 'g']

用作靶子属性的Generator函数

若是多个指标的质量是Generator函数,能够简写成上面包车型大巴款型。

let obj = {
  * myGeneratorMethod() {
    ···
  }
};

上面代码中,myGeneratorMethod特性后面有八个星号,表示那么些天性是1个Generator函数。

它的欧洲经济共同体情势如下,与地方的写法是等价的。

let obj = {
  myGeneratorMethod: function* () {
    // ···
  }
};

Generator函数的this

Generator函数总是回到三个遍历器,ES6明确这些遍历器是Generator函数的实例,也延续了Generator函数的prototype对象上的艺术。

function* g() {}

g.prototype.hello = function () {
  return 'hi!';
};

let obj = g();

obj instanceof g // true
obj.hello() // 'hi!'

上边代码声明,Generator函数g回来的遍历器obj,是g的实例,而且接二连三了g.prototype。但是,如果把g用作普通的构造函数,并不会生效,因为g回去的接连遍历器对象,而不是this对象。

function* g() {
  this.a = 11;
}

let obj = g();
obj.a // undefined

上边代码中,Generator函数gthis对象方面添加了贰本性能a,但是obj对象拿不到这一个性情。

Generator函数也不能够跟new命令一道用,会报错。

function* F() {
  yield this.x = 2;
  yield this.y = 3;
}

new F()
// TypeError: F is not a constructor

上面代码中,new指令跟构造函数F同步行使,结果报错,因为F不是构造函数。

那正是说,有没有措施让Generator函数重返二个例行的目的实例,既能够用next方法,又足以获取健康的this

上边是3个变通方法。首先,生成二个空对象,使用call格局绑定Generator函数内部的this。那样,构造函数调用以后,那个空对象就是Generator函数的实例对象了。

function* F() {
  this.a = 1;
  yield this.b = 2;
  yield this.c = 3;
}
var obj = {};
var f = F.call(obj);

f.next();  // Object {value: 2, done: false}
f.next();  // Object {value: 3, done: false}
f.next();  // Object {value: undefined, done: true}

obj.a // 1
obj.b // 2
obj.c // 3

地方代码中,首先是F内部的this对象绑定obj对象,然后调用它,再次来到多个Iterator对象。那个指标举行贰次next方法(因为F里面有三个yield话语),达成F内部全体代码的运行。那时,全体内部属性都绑定在obj对象上了,由此obj对象也就成了F的实例。

上面代码中,执行的是遍历器对象f,不过变化的目的实例是obj,有没有主意将这多个指标统一啊?

1个措施正是将obj换成F.prototype

function* F() {
  this.a = 1;
  yield this.b = 2;
  yield this.c = 3;
}
var f = F.call(F.prototype);

f.next();  // Object {value: 2, done: false}
f.next();  // Object {value: 3, done: false}
f.next();  // Object {value: undefined, done: true}

f.a // 1
f.b // 2
f.c // 3

再将F改成构造函数,就足以对它实施new命令了。

function* gen() {
  this.a = 1;
  yield this.b = 2;
  yield this.c = 3;
}

function F() {
  return gen.call(gen.prototype);
}

var f = new F();

f.next();  // Object {value: 2, done: false}
f.next();  // Object {value: 3, done: false}
f.next();  // Object {value: undefined, done: true}

f.a // 1
f.b // 2
f.c // 3

含义

Generator与状态机

Generator是促成状态机的极品结构。比如,上面包车型大巴clock函数正是2个状态机。

var ticking = true;
var clock = function() {
  if (ticking)
    console.log('Tick!');
  else
    console.log('Tock!');
  ticking = !ticking;
}

地点代码的clock函数一共有二种情景(Tick和Tock),每运维三次,就改变二回状态。那几个函数假设用Generator实现,便是下面那样。

var clock = function*() {
  while (true) {
    console.log('Tick!');
    yield;
    console.log('Tock!');
    yield;
  }
};

地点的Generator完结与ES5兑现比较,能够看出少了用于保存情状的表面变量ticking,那样就更简短,更安全(状态不会被违规篡改)、更适合函数式编制程序的思想,在写法上也更优雅。Generator之所以能够绝不外部变量保存情状,是因为它本人就富含了一个景观新闻,即日前是或不是处于暂停态。

Generator与协程

协程(coroutine)是一种程序运维的章程,能够领略成“同盟的线程”或“合作的函数”。协程既可以用单线程实现,也得以用二十多线程完成。前者是一种至极的子例程,后者是一种相当的线程。

(1)协程与子例程的差距

历史观的“子例程”(subroutine)采取堆栈式“后进先出”的施汇兑势,唯有当调用的子函数完全履行完毕,才会终止执行父函数。协程与其分歧,四个线程(单线程情状下,即三个函数)能够并行执行,不过只有3个线程(或函数)处刘恒在运维的情景,其余线程(或函数)都处在暂停态(suspended),线程(或函数)之间能够调换执行权。也正是说,3个线程(或函数)执行到六分之三,能够暂停实施,将执行权交给另一个线程(或函数),等到稍后收回执行权的时候,再过来执行。那种能够并行执行、交换执行权的线程(或函数),就称为协程。

从贯彻上看,在内部存款和储蓄器中,子例程只行使二个栈(stack),而协程是还要设有多个栈,但唯有3个栈是在运转意况,也正是说,协程是以多占用内存为代价,完结多职分的互动。

(2)协程与常见线程的差异

不难看出,协程适合用来多职责运营的条件。在这一个意思上,它与平时的线程很相像,都有投机的履行上下文、能够大快朵颐全局变量。它们的分歧之处在于,同一时半刻间可以有四个线程处于运市价况,然而运营的协程只好有一个,其余协程都远在中断状态。其它,普通的线程是超越式的,到底哪些线程优先得到财富,必须由运维环境控制,不过协程是合营式的,执行权由协程自身分配。

由于ECMAScript是单线程语言,只好维持一个调用栈。引入协程未来,种种职分能够保持协调的调用栈。这样做的最大便宜,正是抛出荒唐的时候,能够找到原来的调用栈。不至于像异步操作的回调函数那样,一旦出错,原始的调用栈早就得了。

Generator函数是ECMAScript
6对协程的落到实处,但属于不完全落到实处。Generator函数被号称“半协程”(semi-coroutine),意思是唯有Generator函数的调用者,才能将先后的执行权还给Generator函数。倘诺是一点一滴履行的协程,任何函数都能够让暂停的协程继续执行。

比方将Generator函数当作家协会程,完全能够将两个要求互相合营的职分写成Generator函数,它们中间利用yield语句沟通控制权。

应用

Generator能够暂停函数执行,再次来到任意表明式的值。那种天性使得Generator有二种用参加景。

(1)异步操作的同步化表明

Generator函数的刹车实施的功效,意味着能够把异步操作写在yield语句里面,等到调用next方法时再未来举办。那事实上等同不要求写回调函数了,因为异步操作的延续操作能够放在yield语句上边,反正要等到调用next方法时再实施。所以,Generator函数的3个第壹实际意义就是用来处理异步操作,改写回调函数。

function* loadUI() {
  showLoadingScreen();
  yield loadUIDataAsynchronously();
  hideLoadingScreen();
}
var loader = loadUI();
// 加载UI
loader.next()

// 卸载UI
loader.next()

上边代码表示,第二回调用loadUI函数时,该函数不会实施,仅重回三个遍历器。下一遍对该遍历器调用next方法,则会显得Loading界面,并且异步加载数据。等到数量加载成功,再1回选择next方法,则会隐藏Loading界面。能够见到,那种写法的好处是享有Loading界面包车型地铁逻辑,都被封装在三个函数,遵纪守法格外明晰。

Ajax是第一级的异步操作,通过Generator函数安插Ajax操作,能够用联合的办法表明。

function* main() {
  var result = yield request("http://some.url");
  var resp = JSON.parse(result);
    console.log(resp.value);
}

function request(url) {
  makeAjaxCall(url, function(response){
    it.next(response);
  });
}

var it = main();
it.next();

地点代码的main函数,正是通过Ajax操作获取数据。能够观察,除了多了1个yield,它大致与同步操作的写法完全相同。注意,makeAjaxCall函数中的next方法,必须抬高response参数,因为yield语句构成的表明式,自身是从未有过值的,总是等于undefined。

下边是另3个例子,通过Generator函数逐行读取文本文件。

function* numbers() {
  let file = new FileReader("numbers.txt");
  try {
    while(!file.eof) {
      yield parseInt(file.readLine(), 10);
    }
  } finally {
    file.close();
  }
}

上边代码打开文本文件,使用yield语句可以手动逐行读取文件。

(2)控制流管理

若是有贰个多步操作相当耗费时间,接纳回调函数,或然会写成上边那样。

step1(function (value1) {
  step2(value1, function(value2) {
    step3(value2, function(value3) {
      step4(value3, function(value4) {
        // Do something with value4
      });
    });
  });
});

选拔Promise改写上面的代码。

Promise.resolve(step1)
  .then(step2)
  .then(step3)
  .then(step4)
  .then(function (value4) {
    // Do something with value4
  }, function (error) {
    // Handle any error from step1 through step4
  })
  .done();

地点代码已经把回调函数,改成了直线执行的花样,不过进入了汪洋Promise的语法。Generator函数能够越发革新代码运维流程。

function* longRunningTask(value1) {
  try {
    var value2 = yield step1(value1);
    var value3 = yield step2(value2);
    var value4 = yield step3(value3);
    var value5 = yield step4(value4);
    // Do something with value4
  } catch (e) {
    // Handle any error from step1 through step4
  }
}

然后,使用三个函数,按次序自动执行全部手续。

scheduler(longRunningTask(initialValue));

function scheduler(task) {
  var taskObj = task.next(task.value);
  // 如果Generator函数未结束,就继续调用
  if (!taskObj.done) {
    task.value = taskObj.value
    scheduler(task);
  }
}

只顾,下边这种做法,只适合同步操作,即全部的task都无法不是一块的,不能够有异步操作。因为那里的代码一获得重返值,就无冕往下进行,没有看清异步操作曾几何时完结。若是要控制异步的操作流程,详见前面包车型客车《异步操作》一章。

下面,利用for...of循环会自动依次执行yield指令的性子,提供一种更相像的控制流管理的不二法门。

let steps = [step1Func, step2Func, step3Func];

function *iterateSteps(steps){
  for (var i=0; i< steps.length; i++){
    var step = steps[i];
    yield step();
  }
}

地点代码中,数组steps打包了三个职责的多个步骤,Generator函数iterateSteps则是逐一为那一个步骤加上yield命令。

将职分分解成步骤之后,还足以将品种分解成多个依次执行的天职。

let jobs = [job1, job2, job3];

function *iterateJobs(jobs){
  for (var i=0; i< jobs.length; i++){
    var job = jobs[i];
    yield *iterateSteps(job.steps);
  }
}

上边代码中,数组jobs卷入了3个门类的七个职务,Generator函数iterateJobs则是各种为那一个任务加上yield *命令。

最终,就足以用for...of循环二遍性依次执行全体任务的具有手续。

for (var step of iterateJobs(jobs)){
  console.log(step.id);
}

再度提示,上边的做法只好用来全数手续都以同步操作的情况,不能够有异步操作的步调。假使想要依次执行异步的步调,必须选用后边的《异步操作》一章介绍的章程。

for...of的原形是2个while巡回,所以地点的代码实质上举行的是上边的逻辑。

var it = iterateJobs(jobs);
var res = it.next();

while (!res.done){
  var result = res.value;
  // ...
  res = it.next();
}

(3)部署Iterator接口

利用Generator函数,能够在肆意对象上布置Iterator接口。

function* iterEntries(obj) {
  let keys = Object.keys(obj);
  for (let i=0; i < keys.length; i++) {
    let key = keys[i];
    yield [key, obj[key]];
  }
}

let myObj = { foo: 3, bar: 7 };

for (let [key, value] of iterEntries(myObj)) {
  console.log(key, value);
}

// foo 3
// bar 7

上述代码中,myObj是1个常备对象,通过iterEntries函数,就有了Iterator接口。也便是说,能够在肆意对象上配备next方法。

上边是二个对数组安顿Iterator接口的例证,尽管数组原生具有那一个接口。

function* makeSimpleGenerator(array){
  var nextIndex = 0;

  while(nextIndex < array.length){
    yield array[nextIndex++];
  }
}

var gen = makeSimpleGenerator(['yo', 'ya']);

gen.next().value // 'yo'
gen.next().value // 'ya'
gen.next().done  // true

(4)作为数据结构

Generator可以作为是数据结构,更确切地说,可以看成是多个数组结构,因为Generator函数能够再次来到一各种的值,那意味着它可以对自由表达式,提供类似数组的接口。

function *doStuff() {
  yield fs.readFile.bind(null, 'hello.txt');
  yield fs.readFile.bind(null, 'world.txt');
  yield fs.readFile.bind(null, 'and-such.txt');
}

地点代码就是各类再次回到四个函数,不过由于采纳了Generator函数,导致能够像处理数组这样,处理这多个再次来到的函数。

for (task of doStuff()) {
  // task是一个函数,可以像回调函数那样使用它
}

骨子里,假设用ES5表述,完全能够用数组模拟Generator的那种用法。

function doStuff() {
  return [
    fs.readFile.bind(null, 'hello.txt'),
    fs.readFile.bind(null, 'world.txt'),
    fs.readFile.bind(null, 'and-such.txt')
  ];
}

地点的函数,能够用一模一样的for…of循环处理!两相一比较,就简单看出Generator使得数据如故操作,具备了看似数组的接口。